]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- restore %{debug_package}, this time in %prep overload
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
19                 gettextize --copy --force --no-changelog; \
20         else \
21                 gettextize --copy --force --no-changelog --intl; \
22         fi; \
23         if [ ! -f po/Makevars ]; then \
24                 cp -f po/Makevars{.template,}; \
25         fi; \
26 }
27
28 %__glib_gettextize      glib-gettextize --copy --force
29 %__gnome_doc_common     gnome-doc-common --copy
30 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
31 %__gtkdocize            gtkdocize --copy
32 %__intltoolize          intltoolize --copy --force
33 %__libtoolize           libtoolize --copy --force
34
35 #       The number of cvs changelog entries kept when building package.
36 %_buildchangelogtruncate 20
37
38 %dependencytracking     %{nil}
39
40 #       Relations between package names that cause dependency loops
41 #       with legacy packages that cannot be fixed. Relations are
42 #       specified as
43 #               p>q
44 #       where package p has a Requires: on something that package q Provides:
45 #
46 # XXX   Note: that there cannot be any whitespace within the string "p>q",
47 #       and that both p and q are package names (i.e. no version/release).
48 %_dependency_whiteout   %{nil}
49
50 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
51         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
52         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
53
54 #-----------------------------------------------------------------
55 #
56 # (re)definition of %{rpm*flags} with %filterout_* support
57 # BuildRequires:        awk
58 # BuildRequires:        rpmbuild(macros) >= 1.315
59 #
60 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
61 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
62 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
63 # %rpmldflags   = %optldflags - %filterout_ld
64 #
65 # Regular expressions are supported, but to avoid some character be treated
66 # as regular expression it must be escaped twice.
67
68 %filter_out                                             \
69         for (i = 1; i in I; i++) {      A=0;    \
70                 for (f in F) {                          \
71                         if (I[i] ~ "^" F[f] "$") A=1;   \
72                 };                                                      \
73                 if (!A) printf(I[i] FS);        \
74         }
75
76 %rpmcflags %(awk 'BEGIN {
77         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
78         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
79         %{filter_out}
80 }')
81
82 %rpmcxxflags %(awk 'BEGIN {
83         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
84         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
85         %{filter_out}
86 }')
87
88 %rpmldflags %(awk 'BEGIN {
89         split("%{?optldflags}",I);
90         split("%{?filterout_ld}",F)
91         %{filter_out}
92 }')
93
94 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
95 # but, don't use it, better use gcc as linker
96 %ld_rpmldflags %(awk 'BEGIN {
97         split("%{rpmldflags}",F);
98         for (f in F) {
99                 s = F[f];
100                 if (s ~ /^-Wl,/) {
101                         s = substr(s,5);
102                         gsub(/,/," ",s);
103                 };
104                 printf(s FS);
105         };
106 }')
107
108 #-----------------------------------------------------------------
109 %configure2_13 { \
110  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
111  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
112  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
113  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
114  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
115  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
116  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
117  %{?__cc:CC="%{__cc}" ; export CC ; } \
118  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
119  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
120         --host=%{_target_platform} \
121         --prefix=%{_prefix} \
122         --exec-prefix=%{_exec_prefix} \
123         --bindir=%{_bindir} \
124         --sbindir=%{_sbindir} \
125         --sysconfdir=%{_sysconfdir} \
126         --datadir=%{_datadir} \
127         --includedir=%{_includedir} \
128         --libdir=%{_libdir} \
129         --libexecdir=%{_libexecdir} \
130         --localstatedir=%{_localstatedir} \
131         --sharedstatedir=%{_sharedstatedir} \
132         --mandir=%{_mandir} \
133         --infodir=%{_infodir} \
134         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
135         %{dependencytracking} \
136 }
137
138 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
139 %__cmake        /usr/bin/cmake
140 %cmake { \
141 CC="%{__cc}" \
142 CXX="%{__cxx}" \
143 CFLAGS="%{rpmcflags}" \
144 CXXFLAGS="%{rpmcxxflags}" \
145 %{__cmake} \
146 }
147
148 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
149 %__scons        /usr/bin/scons
150 %scons { \
151 %{__scons} \
152         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
153         CFLAGS="${CFLAGS:-%rpmcflags}" \
154         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
155         FFLAGS="${FFLAGS:-%rpmcflags}" \
156         CPPFLAGS="${CPPFLAGS:-}" \
157         %{?__cc:CC="%{__cc}"} \
158         %{?__cxx:CXX="%{__cxx}"} \
159         libsuffix=%{_lib} \
160         prefix=%{_prefix} \
161 }
162
163 # waf. see waf.spec
164 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
165 %__waf  /usr/bin/waf
166 %waf { \
167 CC="%{__cc}" \
168 CXX="%{__cxx}" \
169 CPP="%{__cpp}" \
170 CFLAGS="%{rpmcflags}" \
171 CXXFLAGS="%{rpmcxxflags}" \
172 %{__waf} \
173 }
174
175 #----------------------------------------------------------------
176 %global configure_cache 0
177 %configure_cache_file   %{buildroot}.configure.cache
178
179 %configure {./configure \
180         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
181         CFLAGS="${CFLAGS:-%rpmcflags}" \
182         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
183         FFLAGS="${FFLAGS:-%rpmcflags}" \
184         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
185         CPPFLAGS="${CPPFLAGS:-}" \
186         %{?__cc:CC="%{__cc}"} \
187         %{?__cxx:CXX="%{__cxx}"} \
188         --host=%{_target_platform} \
189         --build=%{_target_platform} \
190         --prefix=%{_prefix} \
191         --exec-prefix=%{_exec_prefix} \
192         --bindir=%{_bindir} \
193         --sbindir=%{_sbindir} \
194         --sysconfdir=%{_sysconfdir} \
195         --datadir=%{_datadir} \
196         --includedir=%{_includedir} \
197         --libdir=%{_libdir} \
198         --libexecdir=%{_libexecdir} \
199         --localstatedir=%{_localstatedir} \
200         --sharedstatedir=%{_sharedstatedir} \
201         --mandir=%{_mandir} \
202         --infodir=%{_infodir} \
203         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
204         %{dependencytracking} \
205         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
206 }
207
208 # overload to insert debuginfo package
209 %prep \
210 %if 0%{?_enable_debug_packages}\
211 %{debug_package}\
212 %endif\
213 %%prep\
214 %{nil}
215
216 # Location of autoconf macros
217 %_aclocaldir    %(aclocal --print-ac-dir)
218
219 # Location of omf files
220 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
221
222 # Location of pkgconfig files
223 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
224
225 # Location of desktop files
226 %_desktopdir    /usr/share/applications
227 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
228
229 # Location of pixmaps for applnk/desktop files
230 %_pixmapsdir    /usr/share/pixmaps
231
232 # Location of themable icons for applnk/desktop files
233 %_iconsdir      /usr/share/icons
234
235 # Location of fonts directories
236 %_fontsdir      /usr/share/fonts
237
238 # Location of Gtk and associated libraries documentation
239 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
240
241 # Location of KDE documentation
242 %_kdedocdir     %{_defaultdocdir}/kde/HTML
243
244 # unsermake script
245 %__unsermake /usr/share/unsermake/unsermake
246
247 # Current date
248 %date           %(LC_ALL="C" date +"%a %b %d %Y")
249
250 # tmp directory
251 %tmpdir         %(echo "${TMPDIR:-/tmp}")
252
253 # Example files, programs, scripts...
254 %_examplesdir   /usr/src/examples
255
256 # Alternative kernel type/version
257 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
258
259 # The directory holding Linux kernel sources
260 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
261
262 # If non-empty "debug" macro defined, add "dbg" suffix to release number
263 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
264
265 # Requires name = version-release
266 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
267
268 %releq_kernel()                 %((LC_ALL="C" rpm -qf --qf '%%{name} = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
269 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
270 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
271 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
272 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
273 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
274
275 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
276 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
277
278 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
279
280 # kernel version-release handling
281 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
282 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
283 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
284 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
285 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
286
287 # sgml macros
288 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
289 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
290 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
291 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
292 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
293 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
294 %docbook_sgmlcat_fix() { for l in \
295 '' \
296 '  -- default decl --' \
297 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
298 '  -- hacks for opensp --' \
299 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
300 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
301 '' \
302 ; do echo $l; done >> %1 \
303 }
304
305 # vim - "
306
307 # minimum file size needed for compressed documents.
308 # just smaller files than this get larger when compressed.
309 # some stats:
310 # - 0 byte file compressed was 25 bytes .gz
311 # - 39 byte file was compressed as 57
312 # - with test/test.spec@man 158 byte file was compressed also 158
313 %_min_compress_bytes    159
314
315 #-----------------------------------------------------------------
316 # find and gzip all files in %{_mandir} and %{infodir}
317 #
318 # Requires: xargs, find
319 #
320 #%no_install_post_compress_docs 1
321 %__spec_install_post_compress_docs { \
322 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
323         for i in /usr/share/man /usr/X11R6/man; do \
324                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
325                         echo "Compress man pages: $i"; \
326                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
327                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
328                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
329                                 m=$(readlink $a); \
330                                 rm -f $a; \
331                                 echo .so ${m##*/} > $a; \
332                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
333                         done; \
334                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
335                 fi; \
336         done; \
337         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
338                 echo "Compress info pages: %{_infodir}"; \
339                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
340                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
341                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
342         fi; \
343 }; __spec_install_post_compress_docs } }
344
345 #-----------------------------------------------------------------
346 # Strip executable binaries and shared object files
347 #
348 # Requires: find, awk, strip, cut, xargs
349 #
350 # Special macros which affect this process:
351 #%no_install_post_strip 1               # disable stripping at all
352 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
353 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
354 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
355 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
356 #
357 %__spec_install_post_strip {%{!?debug: \
358 %{!?no_install_post_strip:__spec_install_post_strip() { \
359 if [ -d "$RPM_BUILD_ROOT" ]; then \
360         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
361                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
362                 if [ "$modulelist" ]; then \
363                         modulecount=$(echo "$modulelist" | wc -l); \
364                         printf "Stripping %d kernel modules..." $modulecount; \
365                         echo "$modulelist" | xargs -l512 chmod u+w; \
366                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
367                         echo "DONE"; \
368                 fi; \
369         fi; \
370         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}`; \
371         if [ -n "$filelist" ]; then \
372                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
373                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
374                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
375                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
376                 if [ -n "$elfexelist" ]; then \
377                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
378                         chmod u+w $elfexelist; \
379                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
380                         echo "DONE"; \
381                 fi; \
382                 if [ -n "$elfsharedlist" ]; then \
383                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
384                         chmod u+w $elfsharedlist; \
385                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
386                         echo "DONE"; \
387                 fi; \
388                 if [ -n "$archiveslist" ]; then \
389                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
390                         chmod u+w $archiveslist; \
391                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
392                         echo "DONE"; \
393                 fi; \
394         fi; \
395     filelist_all=%{?_autostripall:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}"`}; \
396     filelist_unneeded=%{?_autostripunneeded:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}"`}; \
397     filelist_debug=%{?_autostripdebug:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}"`}; \
398         if [ -n "$filelist_all" ]; then \
399                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
400                 chmod u+w $filelist_all; \
401                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
402                 echo "DONE"; \
403         fi; \
404         if [ -n "$filelist_unneeded" ]; then \
405                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
406                 chmod u+w $filelist_unneeded; \
407                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
408                 echo "DONE"; \
409         fi; \
410         if [ -n "$filelist_debug" ]; then \
411                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
412                 chmod u+w $filelist_debug; \
413                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
414                 echo "DONE"; \
415         fi; \
416 fi; }; __spec_install_post_strip } } }
417
418 #-----------------------------------------------------------------
419 # remove all RPATH from executable binaries and shared object files
420 #
421 # Requires: find, awk, cut, xargs, chrpath, uname
422 #
423 # Special macros which affect this process
424 #%no_install_post_chrpath       1       # disable chrpath at all
425 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
426 #
427 %__spec_install_post_chrpath {%{!?debug: \
428 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
429 if [ -d "$RPM_BUILD_ROOT" ]; then \
430         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
431         if [ -n "$files" ]; then \
432                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
433         fi; \
434         if [ -n "$objs" ]; then \
435                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
436                 echo "$objs" | \
437                 while read file; do \
438                         rpath= ; \
439                         chmod u+w "$file"; \
440                         for dir in `chrpath -l "$file" | \
441                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
442                                         case $dir in \
443                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
444                                                 echo "remove-rpath: $dir in $file"; \
445                                                 ;; \
446                                         * ) \
447                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
448                                                 else rpath="$rpath:$dir" ; fi ; \
449                                                 ;; \
450                                         esac ; \
451                         done ; \
452                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
453                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
454                 done; \
455         fi; \
456 fi; }; __spec_install_post_chrpath } } }
457
458 #-----------------------------------------------------------------
459 # Find and gzip all kernel modules
460 #
461 # Requires: find
462 #
463 #%no_install_post_compress_modules      1
464 %__spec_install_post_compress_modules { \
465 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
466         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
467                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
468                 if [ "$q" ]; then \
469                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
470                         echo "$q" | xargs -r %{__gzip} -9nf; \
471                         echo "DONE"; \
472                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
473                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
474                 fi; \
475         fi; \
476 }; __spec_install_post_compress_modules } }
477
478 # Remove common Perl files we don't package
479 %__spec_install_post_perl_clean {\
480 %{!?no_install_post_perl_clean: \
481 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
482 } }
483
484 #-----------------------------------------------------------------
485 # Update GConf2 schemas
486 #
487 # Requires: GConf2
488 #
489 %gconf_schema_install() \
490         umask 022; \
491         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
492         %{nil}
493
494 %gconf_schema_uninstall() \
495 if [ $1 = 0 ]; then \
496         umask 022; \
497         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
498 fi \
499 %{nil}
500
501 #-----------------------------------------------------------------
502 # Update desktop MIME database
503 # requires: desktop-file-utils
504 #
505 %update_desktop_database_post() {{ \
506         umask 022; \
507         /usr/bin/update-desktop-database -q; \
508 }} \
509 %{nil}
510
511 %update_desktop_database_postun() {{ \
512 if [ $1 = 0 ]; then \
513         umask 022; \
514         /usr/bin/update-desktop-database -q; \
515 fi \
516 }} \
517 %{nil}
518
519 #-----------------------------------------------------------------
520 # Update shared MIME info database
521 # requires: shared-mime-info
522 #
523 %update_mime_database() {{ \
524         umask 022; \
525         /usr/bin/update-mime-database %{_datadir}/mime; \
526 }} \
527 %{nil}
528
529 #-----------------------------------------------------------------
530 # Update icon cache
531 # requires: gtk+
532 #
533 %update_icon_cache() {{ \
534         umask 022; \
535         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
536 }} \
537 %{nil}
538
539 #-----------------------------------------------------------------
540 # Update scrollkeeper database
541 # requires: scrollkeeper
542 #
543 %scrollkeeper_update_post() \
544         /usr/bin/scrollkeeper-update -q; \
545         %{nil}
546
547 %scrollkeeper_update_postun() \
548 if [ $1 = 0 ]; then \
549         /usr/bin/scrollkeeper-update -q; \
550 fi \
551 %{nil}
552
553 #-----------------------------------------------------------------
554 # post %install sequence:
555 # - autodeps exceptions
556 # - compress all man and info pages,
557 # - strip all ELF executables and ELF shared objects if not %debug.
558 # - compress kernel modules if any
559
560 ###################################################################
561 # Requires/Provides automation
562 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
563 #
564 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
565 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
566 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
567 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
568 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
569 #%_noautocompressdoc    %{nil}
570 #
571 %_missing_doc_files_terminate_build     1%{nil}
572 %_unpackaged_files_terminate_build      %{nil}
573 # (X)emacs support
574 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
575 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
576 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
577
578 %__php_provides %{nil}
579 %__php_requires %{nil}
580 %__perl_provides %{nil}
581 %__perl_requires %{nil}
582 %__mono_provides %{nil}
583 %__mono_requires %{nil}
584
585 # Perl specific macro definitions.
586 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
587 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
588 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
589 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
590 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
591 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
592
593 # Ruby
594 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
595 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
596 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
597 %ruby_vendorarchdir     %(ruby -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)
598 %ruby_vendorlibdir      %(ruby -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)
599 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
600 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
601 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
602 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
603 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
604
605 %php_pear_dir           /usr/share/pear
606 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
607 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
608 %php_includedir         %(php-config --include-dir 2>/dev/null || echo ERROR)
609
610 # extract php/zend api versions
611 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
612 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)
613 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
614 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
615 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
616 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
617 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})
618
619 # helper macro
620 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
621
622 # macros for public use
623 # for php extensions (php-pecl)
624 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
625 %{__php_api_requires zend_module_api} \
626 %{__php_api_requires -v %php_major_version debug php_debug} \
627 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
628
629 # for zend extensions
630 %requires_zend_extension %{__php_api_requires zend_module_api} \
631 %{__php_api_requires zend_extension_api} \
632 %{__php_api_requires -v %php_major_version debug php_debug} \
633 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
634
635 # for php pdo modules (php-pecl-PDO_*)
636 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
637
638 # for using PHP post scripts. for PHP >= 5.0
639 %php_webserver_restart \
640 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
641 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
642 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
643         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
644         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
645                 %service -q php-fcgi restart \
646         fi \
647 fi \
648 %{nil}
649
650 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
651 %php4_webserver_restart \
652 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
653 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
654 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
655         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
656         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
657                 %service -q php-fcgi restart \
658         fi \
659 fi \
660 %{nil}
661
662
663 # X.org helper macros
664 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
665 #
666 %xorg_xserver_ansic_abi         %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
667 %xorg_xserver_extension_abi     %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
668 %xorg_xserver_font_abi          %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)
669 %xorg_xserver_videodrv_abi      %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
670 %xorg_xserver_xinput_abi        %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
671
672 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
673 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
674 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
675 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
676 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
677 %{__xorg_abi_requires font xorg_xserver_font_abi}
678 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
679 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
680
681 # Python specific macro definitions.
682 # python main version
683 %py_ver                 %(python -c "import sys; print sys.version[:3]")
684
685 # directories
686 %py_prefix              %(python -c "import sys; print sys.prefix")
687 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
688 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
689 %py_incdir              /usr/include/python%{py_ver}
690 %py_sitedir             %{py_libdir}/site-packages
691 %py_sitescriptdir %{py_scriptdir}/site-packages
692 %py_dyndir              %{py_libdir}/lib-dynload
693
694 # pure python modules compilation
695 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
696
697 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
698
699 # Software written in Python language require Python with main version
700 %pyrequires_eq() Requires:      %1
701
702 # Hardlink binary identical .pyc and .pyo files
703 # (idea by glen <at> pld-linux <dot> org)
704 %__spec_install_post_py_hardlink {\
705 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
706 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
707         b="${a%.pyc}.pyo"; \
708         if cmp -s "$a" "$b"; then \
709                 ln -f "$a" "$b"; \
710         fi; \
711 done \
712 }; __spec_install_post_py_hardlink } }
713
714 # remove python sources, so that check-files won't complain
715 # (idea by glen <at> pld-linux <dot> org)
716 %py_postclean() \
717 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
718  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
719 done \
720 %{nil}
721
722 # depmod macro
723 %depmod() { \
724 umask 022; \
725 if [ -e /boot/System.map-%1 ]; then \
726         /sbin/depmod -a -F /boot/System.map-%1 %1; \
727 else \
728         if [ -e /boot/System.map ]; then \
729                 /sbin/depmod -a -F /boot/System.map %1; \
730         else \
731                 /sbin/depmod -a %1; \
732         fi \
733 fi; \
734 }
735
736 # XMMS specific macros
737 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
738 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
739 %xmms_version                   %(xmms-config --version 2>/dev/null)
740 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
741 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
742 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
743 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
744 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
745 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
746 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
747
748 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
749
750 # user/group checking macros
751 #
752 # Usage:
753 #       %userremove myuser
754 #
755 %userremove     /usr/lib/rpm/user_group.sh user del
756 %groupremove    /usr/lib/rpm/user_group.sh group del
757 #
758 # Usage:
759 #       if %usertestrm myuser; then
760 #               /usr/sbin/userdel -r myuser
761 # Note:
762 #       use these macros only if you need to call userdel/groupdel with
763 #       a non-standard option or take an extra action; otherwise use the
764 #       %userremove/%groupremove macros
765 #
766 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
767 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
768 # user group membership management macros
769 #
770 # Usage:
771 #       %addusertogroup myuser agroup
772 #
773 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
774
775 # banner support (useful in {pre,post}{,un} and triggers)
776 #
777 # Usage:
778 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
779 # the banner text, the banner text
780 # the banner text, and following line
781 #EOF
782 # You can use any form of here-document, <<'EOF' <<-EOT will do.
783 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
784 #
785 # -a   - append to the banner
786 # -e   - send to stderr instead of stdout
787 # -n   - no show banner (overrides -t)
788 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
789 #
790 # Tests:
791 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
792 # rpm -E 'date | %banner -e banner' > m; sh -x m
793 #
794 %banner(aent:) ( \
795 RPM_SCRIPTVERBOSITY=5 \
796 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
797 if [ -x /usr/bin/banner.sh ]; then \
798         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
799 else \
800         CMD="cat%{-e: >&2}" \
801 fi \
802 eval $CMD %{?2:%2}%{?3: %3}) \
803 %{nil}
804
805 # useradd/groupadd macros
806 # Author: Elan Ruusamäe <glen@pld-linux.org>
807 #
808 # Usage:
809 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
810 #   [-g initial_group] [-G group[,...]] login
811 #
812 #  -u uid. REQUIRED
813 #  -g gid/group. REQUIRED
814 #  -s defaults to /bin/false
815 #  -d defaults to /usr/share/empty
816 #  -c No default
817 #  -r is accepted but ignored (it's always set)
818 #  -k skeleton dir. defaults to /usr/share/empty
819 # rpm specific flags
820 #  -P package name. defaults to %{name}
821 #
822 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
823 %{!-u:%{error:useradd: Required argument -u missing}} \
824 %{!-g:%{error:useradd: Required argument -g missing}} \
825 %{!?1:%{error:useradd: Required parameter login missing}} \
826 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
827         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
828                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
829                 exit 1 \
830         fi \
831 else \
832         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
833         /usr/sbin/useradd \\\
834                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
835                 -u %{-u*} \\\
836                 -r \\\
837                 -d %{-d*}%{!-d:/usr/share/empty} \\\
838                 -s %{-s*}%{!-s:/bin/false} \\\
839                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
840                 -g %{-g*} \\\
841                 %{-M} \\\
842                 %{-G:-G %{-G*}} \\\
843                 %{expand:%{%{#}}} 1>&2 || exit $? \
844         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
845 fi;
846
847 # Usage:
848 #   %groupadd [-P package] [-g gid] group
849 #
850 # -g gid. REQUIRED
851 #
852 # Sample:
853 #   %groupadd -P %{name}-base -g %{gid} %{name}
854
855 %groupadd(g:P:rfo)      \
856 %{!-g:%{error:groupadd: Required argument -g missing}} \
857 %{!?1:%{error:groupadd: Required parameter group missing}} \
858 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
859         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
860                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
861                 exit 1 \
862         fi \
863 else \
864         echo "Adding group %{1} GID=%{-g*}." \
865         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
866         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
867 fi;
868
869 # webapp macros
870 # Author: Elan Ruusamäe <glen@pld-linux.org>
871 #
872 # The config is installed/removed inside trigger, this means that you can any
873 # time install apache1/apache/lighttpd package and the configuration file is
874 # updated. if you don't need the config for various reason for specific
875 # webserver, just remove the symlink from config directory using webapp
876 # program. the trigger will not recreate the symlink on upgrades. In other
877 # words the config is linked to webserver config directory on first install of
878 # PACKAGE or WEBSERVER.
879 #
880 # Add package's webserver config to webserver webapps dir.
881 # Usage:
882 #   %webapp_register WEBSERVER WEBAPP
883 #
884 %webapp_register() \
885 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
886 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
887         /usr/sbin/webapp register %1 %2\
888 fi\
889 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
890 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
891         %{expand:%service -q %%1 reload}\
892 fi\
893 %{nil}
894
895 # Remove package's config from webserver webapps dir.
896 # Usage:
897 #   %webapp_register [-f] WEBSERVER WEBAPP
898 %webapp_unregister(f) \
899 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
900 # remove link if either of the packages are gone \
901 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
902         /usr/sbin/webapp unregister %1 %2\
903         %{expand:%service -q %%1 reload}\
904 fi \
905 %{nil}
906
907 # service macro.
908 # Author: Elan Ruusamäe <glen@pld-linux.org>
909 #
910 # calls usual service restart on package %post, but skips the restart if
911 # administrator has disabled automatic service restarts in either global
912 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
913 #
914 # Usage:
915 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
916 #
917 #  -q be silent when service isn't started (for scriplets restaring other package's services)
918 #
919 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
920
921
922 # Java macros. based on jpackage macros.java
923 #
924 # Root directory where all Java VMs/SDK/JREs are installed.
925 %_jvmdir                %{_libdir}/jvm
926
927 # Root directory where all Java VMs/SDK/JREs expose their jars
928 %_jvmjardir             %{_libdir}/jvm-exports
929
930 # Root directory for all Java VM/SDK/JRE's private things.
931 %_jvmprivdir    %{_libdir}/jvm-private
932
933 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
934 %_jvmlibdir             %{_libdir}/jvm
935
936 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
937 %_jvmdatadir    %{_datadir}/jvm
938
939 # Root directory for all configurations parts of Java VM/SDK/JRE's
940 %_jvmsysconfdir %{_sysconfdir}/jvm
941
942 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
943 %_jvmcommonlibdir       %{_libdir}/jvm-common
944
945 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
946 %_jvmcommondatadir      %{_datadir}/jvm-common
947
948 # Root directory for all common configurations parts of Java VM/SDK/JRE's
949 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
950
951 # Directory where arch-specific (JNI) version-independent jars are installed.
952 %_jnidir                %{_libdir}/java
953
954 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
955
956 %ant                    JAVA_HOME=%{java_home} ant
957 %jar                    %{java_home}/bin/jar
958 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
959 %javac                  %{java_home}/bin/javac
960 %javadoc                %{java_home}/bin/javadoc
961
962 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
963
964 %jpackage_script() \
965 install -d $RPM_BUILD_ROOT%{_bindir}\
966 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
967 #!/bin/sh\
968 #\
969 # %{name} script\
970 # JPackage Project <http://www.jpackage.org/>\
971 \
972 # Source functions library\
973 . %{_javadir}-utils/java-functions\
974 \
975 # Source system prefs\
976 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
977     . %{_sysconfdir}/java/%{name}.conf\
978 fi\
979 \
980 # Source user prefs\
981 if [ -f $HOME/.%{name}rc ]; then\
982     . $HOME/.%{name}rc\
983 fi\
984 \
985 # Configuration\
986 MAIN_CLASS=%1\
987 BASE_FLAGS=%2\
988 BASE_OPTIONS=%3\
989 BASE_JARS="%(echo %4 | tr ':' ' ')"\
990 \
991 # Set parameters\
992 set_jvm\
993 set_classpath $BASE_JARS\
994 set_flags $BASE_FLAGS\
995 set_options $BASE_OPTIONS\
996 \
997 # Let's start\
998 run "$@"\
999 EOF
1000
1001 # jpackage 1.7
1002 # Directory for maven depmaps
1003 #
1004 %_mavendepmapdir /etc/maven
1005 %_mavendepmapfragdir /etc/maven/fragments
1006
1007 #
1008 # add_to_depmap adds an entry to the depmap. The arguments are:
1009 #
1010 # %1 the original groupid
1011 # %2 the original artifact id
1012 # %3 the version
1013 # %4 the new groupid
1014 # %5 the new artifactid
1015 #
1016
1017 %add_to_maven_depmap() \
1018 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1019 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1020 <dependency>\
1021     <maven>\
1022         <groupId>%1</groupId>\
1023         <artifactId>%2</artifactId>\
1024         <version>%3</version>\
1025     </maven>\
1026     <jpp>\
1027         <groupId>%4</groupId>\
1028         <artifactId>%5</artifactId>\
1029         <version>%3</version>\
1030     </jpp>\
1031 </dependency>\
1032 \
1033 EOF\
1034 %{nil}
1035
1036 #==============================================================================
1037 #
1038 # update_maven_depmap updates the main maven depmap
1039 #
1040 %update_maven_depmap() \
1041 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1042 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1043 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1044 fi\
1045 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1046
1047
1048 # PEAR install macros
1049 # Author: Elan Ruusamäe <glen@pld-linux.org>
1050 #
1051 # Usage:
1052 #       %%pear_package_setup [-a #] [-n FMT]
1053 #
1054 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1055 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1056 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1057 #
1058 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1059 # destination hierarchy. you should copy the tree to buildroot after
1060 # patching/reorganizing with %%pear_package_install.
1061 #
1062 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1063 # line endings.
1064 #
1065 # the pear install process output is recorded to install.log, you should put it
1066 # to %%doc for later debug or just for information.
1067 #
1068 # additionally additional-packages.txt is produced if it was detected that the
1069 # package has optional dependencies. the file format is suitable of displaying
1070 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1071 # automatically added for this file.
1072
1073
1074 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1075 %__pear_install_log \
1076 tee install.log \
1077 # make post message of optional packages \
1078 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1079 if [ -s optional-packages.txt ]; then \
1080         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1081 else \
1082         rm -f optional-packages.txt \
1083 fi \
1084 %{nil}
1085
1086 # command invoking pear cli
1087 %__pear /usr/bin/pear
1088
1089 %pear_install(a:n:zD) \
1090 %__pear \\\
1091         -c pearrc \\\
1092         -d doc_dir=/docs \\\
1093         -d php_dir=%{php_pear_dir} \\\
1094         -d bin_dir=%{_bindir} \\\
1095         -d data_dir=%{php_pear_dir}/data \\\
1096         -d test_dir=%{php_pear_dir}/tests \\\
1097         install \\\
1098         --packagingroot=%{builddir} \\\
1099         --offline \\\
1100         --nodeps \\\
1101         %{-f:--force} \\\
1102         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1103 %{nil}
1104
1105 # The main macro.
1106 # using this macro will append optional-packages.txt to the nocompressdoc list
1107 # as it's displayed to user after package install. and adding additional gzip
1108 # dep is just waste ;)
1109 %pear_package_setup(a:n:zD) \
1110 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1111 %define builddir %{_builddir}/%{srcdir} \
1112 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1113 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1114 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1115 %pear_install \
1116 %{-z:cd ..} \
1117 cat %{-z:$_N/}.install.log | %__pear_install_log \
1118 \
1119 # undos sources \
1120 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1121 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1122 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1123 %{nil}
1124
1125 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1126 # Author: Elan Ruusamäe <glen@pld-linux.org>
1127 %pear_package_install() \
1128 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1129 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1130 # help the developer out a little: \
1131 if [ -f _noautoreq ]; then \
1132         echo "AutoReqdep detected:" \
1133         echo "_noautoreq $(cat _noautoreq)" \
1134 fi \
1135 %{nil}
1136
1137
1138 # Register OpenLDAP schema.
1139 # Author: Elan Ruusamäe <glen@pld-linux.org>
1140 #
1141 # Usage:
1142 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1143 #
1144 #  -d specify dependant schemas, separated by comma
1145 #
1146 %openldap_schema_register(d:) \
1147 for schema in %*; do \
1148         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1149                 %{__sed} -i -e " \
1150                         /^include.*local.schema/{ \
1151                                 iinclude\\t     $schema\
1152                         } \
1153                 " /etc/openldap/slapd.conf \
1154         fi \
1155 done \
1156 # enable dependant schemas \
1157 if [ "%{-d*}" ]; then \
1158         %{__sed} -i -e ' \
1159         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1160                 s/^#// \
1161         }' /etc/openldap/slapd.conf \
1162 fi \
1163 %{nil}
1164
1165 # Unregister OpenLDAP schema.
1166 # Author: Elan Ruusamäe <glen@pld-linux.org>
1167 #
1168 # Usage:
1169 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1170 #
1171 %openldap_schema_unregister() \
1172 for schema in %*; do \
1173         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1174                 %{__sed} -i -e " \
1175                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1176                 # for symmetry it would be nice if we disable enabled schemas in post, \
1177                 # but we really can not do that, it would break something else. \
1178                 " /etc/openldap/slapd.conf \
1179         fi \
1180 done \
1181 %{nil}
1182
1183 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1184
1185
1186 # Build modules for kernels 2.6
1187 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1188 #
1189 # Usage:
1190 #       %build_kernel_modules -m <modules> -C <directory>
1191 #
1192 #  remember that proper Makefile is still required
1193 # Options:
1194 #  -m <modules> (required) -- comma-separated list of modules to save,
1195 #               without .ko extension, may be placed in subdirectory
1196 #  -C <directory> -- change to <directory> before doing anything
1197 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1198 #  -c -- do not execute make clean
1199 #  <additional arguments> -- all additional arguments will be passed to
1200 #               make modules
1201 #
1202 # Additional patching supported via here document. Try:
1203 #       %build_kernel_modules -m module <<'EOF'
1204 #       your patch script here
1205 #       EOF
1206 # Don't use it unless patching depends on config options.
1207
1208 # Developer note: don't touch it unless you know how to handle '\'.
1209 # - \ in script expands to nothing
1210 # - \\\ in script expands to \
1211 # - \\\ inside definition expands to nothing
1212 # - \\\\\\\ inside definition expands to \
1213 # - in last line \ has to touch arguments so arguments passing
1214 #   in new lines (using \) will be supported
1215
1216 %build_kernel_modules(p:P:m:C:c)                                                                        \
1217 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1218                                                                                                                                         \
1219 %define Opts                                                                                                            \\\\\\\
1220 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1221         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1222         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1223         %else                                                                                                                   \\\
1224         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1225         %endif                                                                                                                  \\\
1226 %else                                                                                                                           \\\
1227         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1228 %endif                                                                                                                          \
1229 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1230                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1231                                                                                                                                         \
1232 %{?-C:cd %{-C*}}                                                                                                        \
1233 compile() {                                                                                                                     \
1234         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1235         set -e -x                                                                                                               \
1236         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1237                                                                                                                                         \
1238 for cfg in ${cfgs:-dist}; do                                        \
1239         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1240                                                                                                                                         \
1241         rm -rf o                                                                                                                \
1242         install -d o/include/linux                                                                              \
1243         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1244         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1245         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1246                                                                                                                                         \
1247         set +x                                                                                                                  \
1248         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1249         set -x                                                                                                                  \
1250                                                                                                                                         \
1251         %if %{with dist_kernel}                                                                                 \
1252                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1253                         %{-p*} %{-P*}                                                                                   \\\
1254                         %{MakeOpts}                                                                                             \
1255         %else                                                                                                                   \
1256                 install -d o/include/config                                                                     \
1257                 touch o/include/config/MARKER                                                           \
1258                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1259         %endif                                                                                                                  \
1260                                                                                                                                         \
1261         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1262                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1263                 M=$PWD %{MakeOpts}}                                                                                     \
1264         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1265                 ${1+"$@"}                                                                                                       \\\
1266                 M=$PWD %{MakeOpts}                                                                                      \
1267                                                                                                                                         \
1268         for MODULE in {%{-m*},}; do                                                                             \
1269                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1270         done                                                                                                                    \
1271 done                                                                                                                            \
1272 %{?-C:cd -}                                                                                                                     \
1273 }                                                                                                                                       \
1274 compile %{*}\
1275 %{nil}
1276
1277
1278 # Install kernel modules built by %build_kernel_modules
1279 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1280 #
1281 # Usage:
1282 #       %install_kernel_modules -m <modules> -d <directory>
1283 #
1284 # Options:
1285 #  -m <modules> (required) -- comma-separated list of modules to install,
1286 #               without .ko extension, may be placed in subdirectory
1287 #  -d <directory> (required) -- in what subdirectory modules should be
1288 #               installed (eg. misc, kernel/drivers/net)
1289 #  -s <suffix> -- suffix to use when installing modules, useful when module
1290 #               with same name exists in kernel already
1291 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1292 #               for defining aliases, only useful with -s
1293
1294 %install_kernel_modules(m:d:s:n:)                                                                       \
1295 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1296 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1297 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1298                                                                                                                                         \
1299 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1300 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1301                                                                                                                                         \
1302 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1303                                                                                                                                         \
1304 for MODULE in {%{-m*},}; do                                                                                     \
1305         [ -n "${MODULE}" ] || continue                                                                  \
1306         for cfg in ${cfgs:-dist}; do                                    \
1307                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1308                 MNAME=${MODULE##*/}                                                                                     \
1309                 install -D ${MODULE}-$cfg.ko                                                            \\\
1310                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1311                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1312                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1313                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1314         done                                                                                                                    \
1315 done                                                                                                                            \
1316 %{nil}
1317
1318 # patchset macros
1319 # Author: Elan Ruusamäe <glen@pld-linux.org>
1320 #
1321 # Usage:
1322 #   %patchset_source -f <seq(1) format> <start> [<end>]
1323 #   %patchset_patch <start> [<end>]
1324 #
1325 # If <end> is omited, it is assumed to be <start>.
1326 #
1327 # For example in preamble:
1328 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1329 # and in %prep:
1330 #  %patchset_patch 33 44
1331
1332 # generate SourceX urls from range START STOP
1333 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1334 # The sources start from 10000
1335 %patchset_source(f:b:) %(
1336         base=%{-b*}%{!-b*:10000};
1337         start=$(expr $base + %1);
1338         end=$(expr $base + %{?2}%{!?2:%{1}});
1339         # we need to call seq twice as it doesn't allow two formats
1340         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1341         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1342         paste %{tmpdir}/__ps{1,2};
1343         rm -f %{tmpdir}/__ps{1,2};
1344 ) \
1345 %{nil}
1346
1347 # apply sources from %patchset_source
1348 # -p specify -pX for %patch line
1349 # -b base offset: defaults to 10000
1350 %patchset_patch(f:p:b:) %(
1351         base=%{-b*}%{!-b*:10000};
1352         start=$(expr $base + %1);
1353         end=$(expr $base + %{?2}%{!?2:%{1}});
1354         echo ": patchset_patch %1%{?2: to %2}";
1355         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1356 ) \
1357 %{nil}
1358
1359 # browser plugins v2
1360 # Author: Elan Ruusamäe <glen@pld-linux.org>
1361 #
1362 # Usage:
1363 #       %browser_plugins_add_browser <name> -p <plugindir>
1364 #
1365 #  <name> (required) -- name of the browser. usually %{name}.
1366 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1367 #  -b -- default blacklists
1368 #  -a <arch> override arch
1369 #
1370 # Example:
1371 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1372
1373 %_browserpluginsconfdir         /etc/browser-plugins
1374 %_browserpluginsdir                     %{_libdir}/browser-plugins
1375 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1376
1377 %browser_plugins_add_browser(p:b:a:) \
1378         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1379         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1380         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1381         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1382         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1383         %{-b:cat >> $blacklist_file %{-b*}} \
1384 %{nil}
1385
1386 # vim:ts=4 sw=4 noet syn=spec
This page took 0.270922 seconds and 4 git commands to generate.